//                                                                      MA_Fibs LOW fill
//______________________________________________________________________________________
#property indicator_chart_window
#property indicator_buffers 11
#property indicator_color1  PowderBlue
#property indicator_color2  CLR_NONE
#property indicator_color3  PowderBlue
#property indicator_color4  CLR_NONE

#property indicator_color5  Blue
#property indicator_color6  Blue
#property indicator_color7  Blue
#property indicator_color8  Blue
#property indicator_color9  Blue
#property indicator_color10 Blue
#property indicator_color11 Blue
#property indicator_width1  5
#property indicator_width3  5
#property indicator_width11 2

#property indicator_style6  STYLE_DOT
#property indicator_style9  STYLE_DOT

extern int  MAPeriod = 250;
extern int  MAType   = 0;
extern bool alertsON = true;
extern int  fibo1    = 382;
extern int  fibo2    = 500;
extern int  fibo3    = 618;
extern int  fibo4    = 1000;
extern int  fibo5    = 1382;
extern int  fibo6    = 1618;

double LineBuffer[];
double Fib1[];
double Fib2[];
double Fib3[];
double Fib4[];
double Fib5[];
double Fib6[];
double fillPowerUP[];
double fillPowerDN[];
double fillOverUP[];
double fillOverDN[];

int    MAMode;
string strMAType;
string IndName;


int init() {
   IndicatorDigits(Digits);
   SetIndexBuffer(10,LineBuffer);
   SetIndexBuffer(7,Fib1);
   SetIndexBuffer(8,Fib2);
   SetIndexBuffer(9,Fib3);
   SetIndexBuffer(4,Fib4);
   SetIndexBuffer(5,Fib5);
   SetIndexBuffer(6,Fib6);
   SetIndexBuffer(0,fillPowerUP);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,fillPowerDN);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,fillOverUP);    SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,fillOverDN);    SetIndexStyle(3,DRAW_HISTOGRAM);
   
   switch (MAType) {
      case 1: strMAType="EMA";  MAMode=MODE_EMA; break;
      case 2: strMAType="SMMA"; MAMode=MODE_SMMA; break;
      case 3: strMAType="LWMA"; MAMode=MODE_LWMA; break;
      case 4: strMAType="LSMA"; break;
      default: strMAType="SMA"; MAMode=MODE_SMA; break;
   }
   
   IndName = strMAType+" ["+MAPeriod+"] LOW";
   IndicatorShortName(IndName);
   
   return(0);
}


int deinit() {
   return(0);
}


int start() {
   double MA;
   int limit;
   int counted_bars = IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;

   for(int i=limit; i>=0; i--) {
      MA = iMA(NULL,0,MAPeriod,0,MAMode,3,i);
      
      LineBuffer[i] = MA;
      Fib1[i] = MA - fibo1*Point;
      Fib2[i] = MA - fibo2*Point;
      Fib3[i] = MA - fibo3*Point;
      Fib4[i] = MA - fibo4*Point;
      Fib5[i] = MA - fibo5*Point;
      Fib6[i] = MA - fibo6*Point;
      
      fillPowerUP[i] = Fib1[i];
      fillPowerDN[i] = Fib3[i];
      fillOverUP[i]  = Fib4[i];
      fillOverDN[i]  = Fib6[i];
   }
   
   manageAlerts();    
   
   return(0);
}


void manageAlerts()
{
   if (alertsON) {
      static datetime time = 0;
      static string   mess = "";
      if (Close[1] < Fib6[1]) doAlert(time,mess,1,", "+IndName+". C  .");
   }
}   


void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
      previousAlert  = doWhat;
      previousTime   = Time[forBar];
      
      string timeFrame = stringToTimeFrame(Period()); 
     
      message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame),doWhat);
      Alert(message);
      PlaySound("alert.wav");
   }
}


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};


int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}


string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}